#pragma once
#include "FileGuard.h"

class PhysicalDisk
{
public:
    PhysicalDisk(const char* path);

    const std::string& GetPath();
    uint32_t SectorSize();

    uint32_t Read(void* buffer, uint32_t length, uint64_t offset);

private:
    FILE* Open();
    uint32_t GetSectorSize();

private:
    std::string m_path;
    FileGuard m_drive;
    uint32_t m_sectorSize;
};
